# BlisModel Class Reference

`#include <BlisModel.h>`

Inheritance diagram for BlisModel:
[legend]
Collaboration diagram for BlisModel:
[legend]

List of all members.

## Public Member Functions
| BlisModel ()
| Default construtor.
virtual | ~BlisModel ()
| Destructor.
void | gutsOfDestructor ()
| Actual destructor.
void | init ()
| Intialize member data.
virtual void | readInstance (const char *dataFile)
| Read in the instance data.
virtual void | readParameters (const int argnum, const char *const *arglist)
| Read in Alps, Blis parameters.
virtual void | writeParameters (std::ostream &outstream) const
| Write out parameters.
virtual AlpsTreeNode * | createRoot ()
| Create the root node based on model.
virtual bool | setupSelf ()
| Do necessary work to make model usable.
virtual void | setSolver (OsiSolverInterface *si)
| Set lp solver.
virtual OsiSolverInterface * | solver ()
| Get lp solver.
bool | resolve ()
| Resolving a lp.
void | setActiveNode (AlpsTreeNode *node)
| Set active node.
void | setSolEstimate (double est)
| Set the solution estimate of the active node.
int | getNumStrong ()
| Get number of strong branchings.
void | addNumStrong (int num=1)
| Add num to number of strong branchings.
double * | getObjCoef () const
| Get objective coefficients.
const double * | getColLower ()
| Get column lower bound.
const double * | getColUpper ()
| Get column upper bound.
int | getNumCols ()
| Get number of columns.
int | getNumRows ()
| Get number of rows.
double * | origVarLB ()
| Get original variable bounds arrary.
double * | origVarUB ()
double * | origConLB ()
| Get original constraint bounds arrary.
double * | origConUB ()
double * | startVarLB ()
| The starting variable bounds arrary of a subproblem (internal use).
double * | startVarUB ()
double * | startConLB ()
| The starting constraint bounds arrary of a subproblem (internal use).
double * | startConUB ()
int * | tempVarLBPos ()
| Temparory storage.
int * | tempVarUBPos ()
int * | tempConLBPos ()
int * | tempConUBPos ()
double | getLpObjValue () const
| Get current objective function value.
const double * | getLpSolution () const
| Get active lp solution.
int | getNumSolutions () const
| Return the stored lp solution.
int | getNumHeurSolutions () const
| Get number of heuristic solutions.
double * | incumbent ()
| Return best ip solution found so far.
bool | setBestSolution (BLIS_SOL_TYPE how, double &objectiveValue, const double *solution, bool fixVariables=false)
| Record a new incumbent solution and update objectiveValue.
double | getCutoff () const
| Get cut off value.
void | setCutoff (double co)
| Set cut off value.
bool | feasibleSolution (int &numIntegerInfs)
| Test the current lp solution for feasiblility.
bool | feasibleSolution (int &numIntegerInfs, int &numObjectInfs)
| Test the current solution for feasiblility.
void | findIntegers (bool startAgain)
| Identify integer variable.
int | getNumIntVars () const
| Get number of integers.
int * | getIntVars () const
| Get integer indices.
bool | checkInteger (double value) const
| Check if a value is integer.
void | addHeuristic (BlisHeuristic *heur)
| Add a heuristic.
BlisHeuristic * | heuristics (int i) const
| Get a specific heuristic.
int | numHeuristics () const
| Get the number of heuristics.
void | addCutGenerator (CglCutGenerator *generator, const char *name=NULL, int strategy=0, bool normal=true, bool atSolution=false, bool whenInfeasible=false)
| Add a cut generator.
BlisConGenerator * | cutGenerators (int i) const
| Get a specific cut generator.
int | numCutGenerators () const
| Get the number of cut generators.
int | getMaxNumCons () const
| Get the max number of cuts can be generated.
void | setMaxNumCons (int m)
| Set the max number of cuts can be generated.
BcpsConstraintPool * | constraintPool ()
| Access constraint pool.
int | useCons () const
| Query constraint generation strategy.
void | setUseCons (int u)
| Set constraint generation strategy.
int | getDenseConCutoff () const
| Get the thresheld to be considered as a dense constraint.
void | setDenseConCutoff (int cutoff)
| Set the thresheld to be considered as a dense constraint.
double * | getConRandoms () const
| Get randoms for check parallel constraints.
void | passInPriorities (const int *priorities, bool ifNotSimpleIntegers, int defaultValue=1000)
| Pass in branching priorities.
const int * | priority () const
| Priorities.
int | priority (int sequence) const
| Returns priority level for an object (or 1000 if no priorities exist).
const double | getNodeWeight () const
void | setNodeWeight (double nw)
virtual void | modelLog ()
| Log of specific models.
int | getNumNodes () const
| Get how many Nodes it took to solve the problem.
int | getNumIterations () const
| Get how many iterations it took to solve the problem.
int | getAveIterations () const
| Get the average iterations it took to solve a lp.
void | addNumNodes (int newNodes=1)
| Increment node count.
void | addNumIterations (int newIter)
| Increment Iteration count.
CoinMessageHandler * | messageHandler () const
| Get the message handler.
int | getHotstartStrategy ()
| Don't know what it is.
void | setHotstartStrategy (int value)
virtual void | registerKnowledge ()
| Register knowledge.
virtual AlpsEncoded * | encode () const
| The method that encodes the model into a encoded object.
virtual void | decodeToSelf (AlpsEncoded &)
| The method that decodes the model from a encoded object.
| BlisModel ()
| Default construtor.
virtual | ~BlisModel ()
| Destructor.
void | gutsOfDestructor ()
| Actual destructor.
void | setColMatrix (CoinPackedMatrix *mat)
| Pass a matrix in.
void | setNumCons (int num)
| Pass column upper bounds.
void | setNumVars (int num)
| Pass column upper bounds.
void | setNumElems (int num)
| Pass column upper bounds.
void | setConLb (double *cl)
| Pass column upper bounds.
void | setConUb (double *cu)
| Pass column lower bounds.
void | setVarLb (double *lb)
| Pass variable upper bounds.
void | setVarUb (double *ub)
| Pass variable lower bounds.
void | setColType (char *colType)
| Pass variable types.
void | setObjCoef (double *obj)
| Pass objective coefficients.
virtual void | readInstance (const char *dataFile)
| For parallel code, only the master calls this function.
virtual void | importModel (std::vector< BlisVariable * > vars, std::vector< BlisConstraint * > cons)
| For parallel code, only the master calls this function.
virtual void | readParameters (const int argnum, const char *const *arglist)
| Read in Alps, Blis parameters.
virtual void | writeParameters (std::ostream &outstream) const
| Write out parameters.
virtual AlpsTreeNode * | createRoot ()
| For parallel code, only the master calls this function.
virtual bool | setupSelf ()
| All processes call this function.
virtual void | preprocess ()
| Preprocessing the model.
virtual void | postprocess ()
| Postprocessing the searching results.
virtual void | setSolver (OsiSolverInterface *si)
| Set lp solver.
virtual OsiSolverInterface * | getSolver ()
| Get lp solver.
virtual OsiSolverInterface * | solver ()
| Get lp solver.
bool | resolve ()
| Resolving a lp.
void | setActiveNode (AlpsTreeNode *node)
| Set active node.
void | setSolEstimate (double est)
| Set the solution estimate of the active node.
int | getNumStrong ()
| Get number of strong branchings.
void | addNumStrong (int num=1)
| Add num to number of strong branchings.
int | getNumBranchResolve ()
| Get the maximum number of resolve during branching.
void | setNumBranchResolve (int num)
| Set the maximum number of resolve during branching.
double * | getObjCoef () const
| Get objective coefficients.
const double * | getColLower ()
| Get column lower bound.
const double * | getColUpper ()
| Get column upper bound.
int | getNumCols ()
| Get number of columns.
int | getNumRows ()
| Get number of rows.
double * | varLB ()
| Get variable bounds arrary.
double * | varUB ()
double * | conLB ()
| Get original constraint bounds arrary.
double * | conUB ()
double * | startVarLB ()
| The starting variable bounds arrary of a subproblem (internal use).
double * | startVarUB ()
double * | startConLB ()
| The starting constraint bounds arrary of a subproblem (internal use).
double * | startConUB ()
int * | tempVarLBPos ()
| Temparory storage.
int * | tempVarUBPos ()
int * | tempConLBPos ()
int * | tempConUBPos ()
double | getLpObjValue () const
| Get current objective function value.
const double * | getLpSolution () const
| Get active lp solution.
int | getNumSolutions () const
| Get number of solutions.
int | getNumHeurSolutions () const
| Get number of heuristic solutions.
double * | incumbent ()
| Return best ip solution found so far.
int | storeSolution (BlisSolutionType how, BlisSolution *sol)
| Record a new incumbent solution and update objectiveValue.
double | getCutoff () const
| Get cut off value.
void | setCutoff (double co)
| Set cut off value.
BlisSolution * | feasibleSolutionHeur (const double *solution)
| Test if a solution found by heuristic is feasible.
virtual BlisSolution * | feasibleSolution (int &numIntegerInfs, int &numObjectInfs)
| Test the current LP solution for feasiblility.
virtual BlisSolution * | userFeasibleSolution (const double *solution, bool &feasible)
| User's criteria for a feasible solution.
void | createIntgerObjects (bool startAgain)
| Identify integer variable.
int * | getIntObjIndices () const
| Get integers' object indices.
int | getNumIntObjects () const
| Get number of integers.
int * | getIntColIndices () const
| Get integers' column indices.
bool | checkInteger (double value) const
| Check if a value is integer.
void | analyzeObjective ()
void | addHeuristic (BlisHeuristic *heur)
| Add a heuristic.
BlisHeuristic * | heuristics (int i) const
| Get a specific heuristic.
int | numHeuristics () const
| Get the number of heuristics.
void | addCutGenerator (BlisConGenerator *generator)
| Add a Blis cut generator.
void | addCutGenerator (CglCutGenerator *generator, const char *name=NULL, BlisCutStrategy strategy=BlisCutStrategyAuto, int cutGenerationFrequency=1, bool normal=true, bool atSolution=false, bool whenInfeasible=false)
| Add a Cgl cut generator.
BlisConGenerator * | cutGenerators (int i) const
| Get a specific cut generator.
int | numCutGenerators () const
| Get the number of cut generators.
int | getMaxNumCons () const
| Get the max number of cuts can be generated.
void | setMaxNumCons (int m)
| Set the max number of cuts can be generated.
BcpsConstraintPool * | constraintPool ()
| Access constraint pool.
BcpsConstraintPool * | constraintPoolReceive ()
| Access receive constraint pool.
BcpsConstraintPool * | constraintPoolSend ()
| Access send constraint pool.
BlisCutStrategy | getCutStrategy () const
| Query constraint generation strategy.
void | setCutStrategy (BlisCutStrategy u)
| Set constraint generation strategy.
int | getCutGenerationFrequency () const
| Query constraint generation frequency.
void | setCutStrategy (int f)
| Set constraint generation frequency.
int | getDenseConCutoff () const
| Get the thresheld to be considered as a dense constraint.
void | setDenseConCutoff (int cutoff)
| Set the thresheld to be considered as a dense constraint.
double * | getConRandoms () const
| Get randoms for check parallel constraints.
void | passInPriorities (const int *priorities, bool ifNotSimpleIntegers, int defaultValue=1000)
| Pass in branching priorities.
const int * | priority () const
| Priorities.
int | priority (int sequence) const
| Returns priority level for an object (or 1000 if no priorities exist).
double | getNodeWeight () const
void | setNodeWeight (double nw)
virtual void | modelLog ()
| Log of specific models.
int | getNumNodes () const
| Get how many Nodes it took to solve the problem.
int | getNumIterations () const
| Get how many iterations it took to solve the problem.
int | getAveIterations () const
| Get the average iterations it took to solve a lp.
void | addNumNodes (int newNodes=1)
| Increment node count.
void | addNumIterations (int newIter)
| Increment Iteration count.
CoinMessageHandler * | blisMessageHandler () const
| Get the message handler.
CoinMessages | blisMessages ()
| Return messages.
virtual void | nodeLog (AlpsTreeNode *node, bool force)
| Node log.
virtual bool | fathomAllNodes ()
| Return true, if all nodes can be fathomed.
virtual void | registerKnowledge ()
| Register knowledge.
virtual AlpsEncoded * | encode () const
| The method that encodes the model into an encoded object.
virtual void | decodeToSelf (AlpsEncoded &)
| The method that decodes the model from an encoded object.
virtual AlpsEncoded * | packSharedKnowlege ()
| Pack knowledge to be shared with others into an encoded object.
virtual void | unpackSharedKnowledge (AlpsEncoded &)
| Unpack and store shared knowledge from an encoded object.
virtual void | presolveForTheWholeTree ()
Branching Strategys
See the BcpsBranchStrategy class for additional information.
BcpsBranchStrategy * | branchStrategy () const
| Get the current branching strategy.
void | setBranchingMethod (BcpsBranchStrategy *method)
| Set the branching strategy.
void | setBranchingMethod (BcpsBranchStrategy &method)
| Set the branching stratedy.
BcpsBranchStrategy * | branchStrategy () const
| Get the current branching strategy.
void | setBranchingMethod (BcpsBranchStrategy *method)
| Set the branching strategy.
void | setBranchingMethod (BcpsBranchStrategy &method)
| Set the branching stratedy.
BcpsBranchStrategy * | rampUpBranchStrategy () const
| Get the current branching strategy.
Object manipulation routines
int | numObjects () const
| Get the number of objects.
void | setNumObjects (int num)
| Set the number of objects.
BcpsObject ** | objects ()
| Get the array of objects.
BcpsObject * | objects (int which)
| Get the specified object.
void | deleteObjects ()
| Delete all object information.
void | addObjects (int numObjects, BcpsObject **objects)
| Add in object information.
int | numObjects () const
| Get the number of objects.
void | setNumObjects (int num)
| Set the number of objects.
BcpsObject ** | objects ()
| Get the array of objects.
BcpsObject * | objects (int which)
| Get the specified object.
void | setSharedObjectMark (int i)
| Mark object to be shared.
void | clearSharedObjectMark ()
| Clear all the share mark.
void | deleteObjects ()
| Delete all object information.
void | addObjects (int numObjects, BcpsObject **objects)
| Add in object information.
## Public Attributes
bool | isRoot_
| If root node.
double | startTime_
| Search starting time.
double | timeLimit_
| Max solution time.
double | integerTol_
| Integer tolerance.
double | optimalRelGap_
| Relative optimal gap.
double | optimalAbsGap_
| Absolute optimal gap.
bool | useHeuristics_
| If use heuristics.
OsiCuts | newCutPool_
| Store new cuts in each pass.
std::vector< AlpsTreeNode * > | leafToRootPath
| Record the path from leaf to root.
int | boundingPass_
| The number of passes during bounding procedure.
double | currRelGap_
| Current relative optimal gap.
double | currAbsGap_
| Current absolute optimal gap.
BlisHeurStrategy | heurStrategy_
| If use heuristics.
int | heurCallFrequency_
| Frequency of using heuristics.
## Protected Member Functions
void | init ()
| Intialize member data.
void | createObjects ()
| Create variables and constraints.
AlpsReturnStatus | encodeBlis (AlpsEncoded *encoded) const
| Pack Blis portion of the model into an encoded object.
AlpsReturnStatus | decodeBlis (AlpsEncoded &encoded)
| Unpack Blis portion of the model from an encoded object.
void | packSharedPseudocost (AlpsEncoded *encoded, int numToShare)
| Retrieve and pack shared pseudocost.
void | unpackSharedPseudocost (AlpsEncoded &encoded)
| Unpack and store shared pseduocost.
void | packSharedConstraints (AlpsEncoded *encoded)
| Retrieve and pack shared constraints.
void | unpackSharedConstraints (AlpsEncoded &encoded)
| Unpack and store shared constraints.
void | packSharedVariables (AlpsEncoded *encoded)
| Retrieve and pack shared variables.
void | unpackSharedVariables (AlpsEncoded &encoded)
| Unpack and store shared variables.
## Protected Attributes
OsiSolverInterface * | origLpSolver_
| Input by user.
OsiSolverInterface * | presolvedLpSolver_
| Presolved.
BlisPresolve * | presolve_
bool | presolved
bool | problemSetup
int * | intObjIndices_
BcpsBranchStrategy * | rampUpBranchStrategy_
BlisHotStartStrategy | hotstartStrategy_
char * | sharedObjectMark_
| The objects that can be shared.
int | numBranchResolve_
| Maximum number of resolve during branching.
BlisCutStrategy | cutStrategy_
| If use cut generators.
int | cutGenerationFrequency_
| Frequency of cut generation.
CoinMessageHandler * | blisMessageHandler_
| Message handler.
CoinMessages | blisMessages_
| Blis messages.
BcpsConstraintPool * | constraintPoolSend_
| Constraints that can be sent/broadcasted to other processes.
BcpsConstraintPool * | constraintPoolReceive_
| Constraints that are received from other processses.
## Private Attributes
OsiSolverInterface * | lpSolver_
| Lp solver.
CoinPackedMatrix * | colMatrix_
| Orignial column majored matrix.
int | numSolutions_
int | numHeurSolutions_
double | incObjValue_
| Saved lp solution for temporatory usage.
double * | incumbent_
| Incumbent.
double | cutoff_
| Cutoff in lp solver.
double | cutoffInc_
| Cutoff increment.
BcpsBranchStrategy * | branchStrategy_
| Variable selection function.
int | hotstartStrategy_
int | numObjects_
| Number of objects.
BcpsObject ** | objects_
| The set of objects.
int * | priority_
| Priorities of integer object.
AlpsTreeNode * | activeNode_
| Active node.
int | numStrong_
| Number of strong branching.
double | nodeWeight_
int | numHeuristics_
| Number of heuristics.
BlisHeuristic ** | heuristics_
| The list of heuristics.
int | useCons_
| If use cut generators.
int | numCutGenerators_
| Number of cut generators used.
int | maxNumCons_
| Number of cuts can be generators.
BlisConGenerator ** | generators_
| The list of cut generators used.
BcpsConstraintPool * | constraintPool_
| Store all the cuts.
BlisConstraint ** | oldConstraints_
| Temporary store old cuts at a node when installing a node.
int | oldConstraintsSize_
| The memory size allocated for oldConstraints_.
int | numOldConstraints_
| Number of old constraints.
double * | conRandoms_
| Random keys.
int | denseConCutoff_
| Dense constraint cutoff.
BlisParams * | BlisPar_
| Blis parameters.
CoinMessageHandler * | handler_
| Message handler.
int | numNodes_
| Number of processed nodes.
int | numIterations_
| Number of lp(Simplex) iterations.
int | aveIterations_
| Average number of lp iterations to solve a subproblem.
double * | origVarLB_
| Original variable and constraint bounds.
double * | origVarUB_
| Original variable and constraint bounds.
double * | origConLB_
| Original variable and constraint bounds.
double * | origConUB_
| Original variable and constraint bounds.
int | numCols_
| Number of columns/rows/elements in active subproblem.
int | numRows_
| Original variable and constraint bounds.
int | numElems_
| Original variable and constraint bounds.
double | objSense_
| Objective function.
double * | objCoef_
| Original variable and constraint bounds.
int | numIntVars_
| Column types.
int * | intVars_
| Original variable and constraint bounds.
char * | colType_
| Original variable and constraint bounds.
double * | startVarLB_
| Starting var/con bounds for processing each node.
double * | startVarUB_
| Original variable and constraint bounds.
double * | startConLB_
| Original variable and constraint bounds.
double * | startConUB_
| Original variable and constraint bounds.
int * | tempVarLBPos_
| Tempory storage for var/con indices.
int * | tempVarUBPos_
| Original variable and constraint bounds.
int * | tempConLBPos_
| Original variable and constraint bounds.
int * | tempConUBPos_
| Original variable and constraint bounds.
double * | varLB_
| Variable and constraint bounds.
double * | varUB_
| Original variable and constraint bounds.
double * | conLB_
| Original variable and constraint bounds.
double * | conUB_
| Original variable and constraint bounds.
int | numIntObjects_
| Column types.
int * | intColIndices_
| Original variable and constraint bounds.
std::vector< BcpsVariable * > | inputVar_
| User's input objects.
std::vector< BcpsConstraint * > | inputCon_
| Original variable and constraint bounds.
int | getNumOldConstraints () const
| Get number of old constraints.
void | setNumOldConstraints (int num)
| Set number of old constraints.
int | getOldConstraintsSize () const
| Get max number of old constraints.
void | setOldConstraintsSize (int num)
| Set max number of old constraints.
BlisConstraint ** | oldConstraints ()
| Access old constraints.
void | setOldConstraints (BlisConstraint **old)
| set old constraints.
void | delOldConstraints ()
| Set max number of old constraints.
BlisParams * | BlisPar ()
| Access parameters.
int | getNumOldConstraints () const
| Get number of old constraints.
void | setNumOldConstraints (int num)
| Set number of old constraints.
int | getOldConstraintsSize () const
| Get max number of old constraints.
void | setOldConstraintsSize (int num)
| Set max number of old constraints.
BlisConstraint ** | oldConstraints ()
| Access old constraints.
void | setOldConstraints (BlisConstraint **old)
| set old constraints.
void | delOldConstraints ()
| Set max number of old constraints.
BlisParams * | BlisPar ()
| Access parameters.

## Detailed Description

Definition at line 60 of file BlisModel.h.

## Constructor & Destructor Documentation

BlisModel::BlisModel | ( |  | ) | `[inline]`

Default construtor.

Definition at line 276 of file BlisModel.h.

virtual BlisModel::~BlisModel | ( |  | ) | `[virtual]`

Destructor.

BlisModel::BlisModel | ( |  | ) | `[inline]`

Default construtor.

Definition at line 339 of file BlisModel.h.

virtual BlisModel::~BlisModel | ( |  | ) | `[virtual]`

Destructor.

## Member Function Documentation

void BlisModel::gutsOfDestructor | ( |  | ) |

Actual destructor.

void BlisModel::init | ( |  | ) |

Intialize member data.

virtual void BlisModel::readInstance | ( | const char * | dataFile | ) | `[virtual]`

Read in the instance data.

Reimplemented from AlpsModel.

Reimplemented in VrpModel.

virtual void BlisModel::readParameters | ( | const int | argnum,
|  | const char *const * | arglist |
| ) |  |  | `[virtual]`

Read in Alps, Blis parameters.

Reimplemented from AlpsModel.

Reimplemented in VrpModel.

virtual void BlisModel::writeParameters | ( | std::ostream & | outstream | ) | const`[virtual]`

Write out parameters.

Reimplemented from AlpsModel.

virtual AlpsTreeNode* BlisModel::createRoot | ( |  | ) | `[virtual]`

Create the root node based on model.

Reimplemented from AlpsModel.

virtual bool BlisModel::setupSelf | ( |  | ) | `[virtual]`

Do necessary work to make model usable.

Return success or not.

Reimplemented from AlpsModel.

virtual void BlisModel::setSolver | ( | OsiSolverInterface * | si | ) | `[inline, virtual]`

Set lp solver.

Definition at line 307 of file BlisModel.h.

virtual OsiSolverInterface* BlisModel::solver | ( |  | ) | `[inline, virtual]`

Get lp solver.

Definition at line 310 of file BlisModel.h.

bool BlisModel::resolve | ( |  | ) |

Resolving a lp.

void BlisModel::setActiveNode | ( | AlpsTreeNode * | node | ) | `[inline]`

Set active node.

Definition at line 316 of file BlisModel.h.

void BlisModel::setSolEstimate | ( | double | est | ) | `[inline]`

Set the solution estimate of the active node.

Definition at line 319 of file BlisModel.h.

int BlisModel::getNumStrong | ( |  | ) | `[inline]`

Get number of strong branchings.

Definition at line 322 of file BlisModel.h.

void BlisModel::addNumStrong | ( | int | num = `1` | ) | `[inline]`

Add num to number of strong branchings.

Definition at line 325 of file BlisModel.h.

double* BlisModel::getObjCoef | ( |  | ) | const`[inline]`

Get objective coefficients.

Definition at line 332 of file BlisModel.h.

const double* BlisModel::getColLower | ( |  | ) | `[inline]`

Get column lower bound.

Definition at line 335 of file BlisModel.h.

const double* BlisModel::getColUpper | ( |  | ) | `[inline]`

Get column upper bound.

Definition at line 338 of file BlisModel.h.

int BlisModel::getNumCols | ( |  | ) | `[inline]`

Get number of columns.

Definition at line 341 of file BlisModel.h.

int BlisModel::getNumRows | ( |  | ) | `[inline]`

Get number of rows.

Definition at line 344 of file BlisModel.h.

double* BlisModel::origVarLB | ( |  | ) | `[inline]`

Get original variable bounds arrary.

Definition at line 347 of file BlisModel.h.

double* BlisModel::origVarUB | ( |  | ) | `[inline]`

Definition at line 348 of file BlisModel.h.

double* BlisModel::origConLB | ( |  | ) | `[inline]`

Get original constraint bounds arrary.

Definition at line 351 of file BlisModel.h.

double* BlisModel::origConUB | ( |  | ) | `[inline]`

Definition at line 352 of file BlisModel.h.

double* BlisModel::startVarLB | ( |  | ) | `[inline]`

The starting variable bounds arrary of a subproblem (internal use).

Definition at line 355 of file BlisModel.h.

double* BlisModel::startVarUB | ( |  | ) | `[inline]`

Definition at line 356 of file BlisModel.h.

double* BlisModel::startConLB | ( |  | ) | `[inline]`

The starting constraint bounds arrary of a subproblem (internal use).

Definition at line 359 of file BlisModel.h.

double* BlisModel::startConUB | ( |  | ) | `[inline]`

Definition at line 360 of file BlisModel.h.

int* BlisModel::tempVarLBPos | ( |  | ) | `[inline]`

Temparory storage.

Definition at line 363 of file BlisModel.h.

int* BlisModel::tempVarUBPos | ( |  | ) | `[inline]`

Definition at line 364 of file BlisModel.h.

int* BlisModel::tempConLBPos | ( |  | ) | `[inline]`

Definition at line 365 of file BlisModel.h.

int* BlisModel::tempConUBPos | ( |  | ) | `[inline]`

Definition at line 366 of file BlisModel.h.

double BlisModel::getLpObjValue | ( |  | ) | const`[inline]`

Get current objective function value.

Definition at line 373 of file BlisModel.h.

const double* BlisModel::getLpSolution | ( |  | ) | const`[inline]`

Get active lp solution.

Definition at line 376 of file BlisModel.h.

int BlisModel::getNumSolutions | ( |  | ) | const`[inline]`

Return the stored lp solution.

Get number of solutions.

Definition at line 386 of file BlisModel.h.

int BlisModel::getNumHeurSolutions | ( |  | ) | const`[inline]`

Get number of heuristic solutions.

Definition at line 389 of file BlisModel.h.

double* BlisModel::incumbent | ( |  | ) | `[inline]`

Return best ip solution found so far.

Definition at line 392 of file BlisModel.h.

bool BlisModel::setBestSolution | ( | BLIS_SOL_TYPE | how,
|  | double & | objectiveValue,
|  | const double * | solution,
|  | bool | fixVariables = `false` |
| ) |  |  |

Record a new incumbent solution and update objectiveValue.

double BlisModel::getCutoff | ( |  | ) | const`[inline]`

Get cut off value.

Definition at line 401 of file BlisModel.h.

void BlisModel::setCutoff | ( | double | co | ) | `[inline]`

Set cut off value.

Definition at line 404 of file BlisModel.h.

bool BlisModel::feasibleSolution | ( | int & | numIntegerInfs | ) |

Test the current lp solution for feasiblility.

Scan integer objects for indications of infeasibility.

bool BlisModel::feasibleSolution | ( | int & | numIntegerInfs,
|  | int & | numObjectInfs |
| ) |  |  |

Test the current solution for feasiblility.

Scan all objects for indications of infeasibility. This is broken down into simple integer infeasibility (`numIntegerInfs`) and all other reports of infeasibility(`numObjectInfs`).

BcpsBranchStrategy* BlisModel::branchStrategy | ( |  | ) | const`[inline]`

Get the current branching strategy.

Definition at line 431 of file BlisModel.h.

void BlisModel::setBranchingMethod | ( | BcpsBranchStrategy * | method | ) | `[inline]`

Set the branching strategy.

Definition at line 435 of file BlisModel.h.

void BlisModel::setBranchingMethod | ( | BcpsBranchStrategy & | method | ) | `[inline]`

Set the branching stratedy.

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 441 of file BlisModel.h.

int BlisModel::numObjects | ( |  | ) | const`[inline]`

Get the number of objects.

Definition at line 451 of file BlisModel.h.

void BlisModel::setNumObjects | ( | int | num | ) | `[inline]`

Set the number of objects.

Definition at line 454 of file BlisModel.h.

BcpsObject** BlisModel::objects | ( |  | ) | `[inline]`

Get the array of objects.

Definition at line 457 of file BlisModel.h.

BcpsObject* BlisModel::objects | ( | int | which | ) | `[inline]`

Get the specified object.

Definition at line 460 of file BlisModel.h.

void BlisModel::deleteObjects | ( |  | ) |

Delete all object information.

void BlisModel::addObjects | ( | int | numObjects,
|  | BcpsObject ** | objects |
| ) |  |  |

Add in object information.

Objects are cloned; the owner can delete the originals.

void BlisModel::findIntegers | ( | bool | startAgain | ) |

Identify integer variable.

int BlisModel::getNumIntVars | ( |  | ) | const`[inline]`

Get number of integers.

Definition at line 474 of file BlisModel.h.

int* BlisModel::getIntVars | ( |  | ) | const`[inline]`

Get integer indices.

Definition at line 477 of file BlisModel.h.

bool BlisModel::checkInteger | ( | double | value | ) | const`[inline]`

Check if a value is integer.

Definition at line 480 of file BlisModel.h.

void BlisModel::addHeuristic | ( | BlisHeuristic * | heur | ) |

Add a heuristic.

BlisHeuristic* BlisModel::heuristics | ( | int | i | ) | const`[inline]`

Get a specific heuristic.

Definition at line 499 of file BlisModel.h.

int BlisModel::numHeuristics | ( |  | ) | const`[inline]`

Get the number of heuristics.

Definition at line 502 of file BlisModel.h.

void BlisModel::addCutGenerator | ( | CglCutGenerator * | generator,
|  | const char * | name = `NULL`,
|  | int | strategy = `0`,
|  | bool | normal = `true`,
|  | bool | atSolution = `false`,
|  | bool | whenInfeasible = `false` |
| ) |  |  |

Add a cut generator.

BlisConGenerator* BlisModel::cutGenerators | ( | int | i | ) | const`[inline]`

Get a specific cut generator.

Definition at line 517 of file BlisModel.h.

int BlisModel::numCutGenerators | ( |  | ) | const`[inline]`

Get the number of cut generators.

Definition at line 520 of file BlisModel.h.

int BlisModel::getMaxNumCons | ( |  | ) | const`[inline]`

Get the max number of cuts can be generated.

Definition at line 523 of file BlisModel.h.

void BlisModel::setMaxNumCons | ( | int | m | ) | `[inline]`

Set the max number of cuts can be generated.

Definition at line 526 of file BlisModel.h.

BcpsConstraintPool* BlisModel::constraintPool | ( |  | ) | `[inline]`

Access constraint pool.

Definition at line 529 of file BlisModel.h.

int BlisModel::getNumOldConstraints | ( |  | ) | const`[inline]`

Get number of old constraints.

Definition at line 533 of file BlisModel.h.

void BlisModel::setNumOldConstraints | ( | int | num | ) | `[inline]`

Set number of old constraints.

Definition at line 536 of file BlisModel.h.

int BlisModel::getOldConstraintsSize | ( |  | ) | const`[inline]`

Get max number of old constraints.

Definition at line 539 of file BlisModel.h.

void BlisModel::setOldConstraintsSize | ( | int | num | ) | `[inline]`

Set max number of old constraints.

Definition at line 542 of file BlisModel.h.

BlisConstraint** BlisModel::oldConstraints | ( |  | ) | `[inline]`

Access old constraints.

Definition at line 545 of file BlisModel.h.

void BlisModel::setOldConstraints | ( | BlisConstraint ** | old | ) | `[inline]`

set old constraints.

Definition at line 548 of file BlisModel.h.

void BlisModel::delOldConstraints | ( |  | ) | `[inline]`

Set max number of old constraints.

Definition at line 551 of file BlisModel.h.

int BlisModel::useCons | ( |  | ) | const`[inline]`

Query constraint generation strategy.

Definition at line 558 of file BlisModel.h.

void BlisModel::setUseCons | ( | int | u | ) | `[inline]`

Set constraint generation strategy.

Definition at line 561 of file BlisModel.h.

int BlisModel::getDenseConCutoff | ( |  | ) | const`[inline]`

Get the thresheld to be considered as a dense constraint.

Definition at line 564 of file BlisModel.h.

void BlisModel::setDenseConCutoff | ( | int | cutoff | ) | `[inline]`

Set the thresheld to be considered as a dense constraint.

Definition at line 567 of file BlisModel.h.

double* BlisModel::getConRandoms | ( |  | ) | const`[inline]`

Get randoms for check parallel constraints.

Definition at line 570 of file BlisModel.h.

void BlisModel::passInPriorities | ( | const int * | priorities,
|  | bool | ifNotSimpleIntegers,
|  | int | defaultValue = `1000` |
| ) |  |  |

Pass in branching priorities.

If ifClique then priorities are on cliques otherwise priorities are on integer variables. Other type (if exists set to default) 1 is highest priority. (well actually -INT_MAX is but that's ugly) If hotstart > 0 then branches are created to force the variable to the value given by best solution. This enables a sort of hot start. The node choice should be greatest depth and hotstart should normally be switched off after a solution.

If ifNotSimpleIntegers true then appended to normal integers

const int* BlisModel::priority | ( |  | ) | const`[inline]`

Priorities.

Definition at line 595 of file BlisModel.h.

int BlisModel::priority | ( | int | sequence | ) | const`[inline]`

Returns priority level for an object (or 1000 if no priorities exist).

Definition at line 598 of file BlisModel.h.

const double BlisModel::getNodeWeight | ( |  | ) | const`[inline]`

Definition at line 603 of file BlisModel.h.

void BlisModel::setNodeWeight | ( | double | nw | ) | `[inline]`

Definition at line 605 of file BlisModel.h.

virtual void BlisModel::modelLog | ( |  | ) | `[virtual]`

Log of specific models.

Reimplemented from AlpsModel.

int BlisModel::getNumNodes | ( |  | ) | const`[inline]`

Get how many Nodes it took to solve the problem.

Definition at line 616 of file BlisModel.h.

int BlisModel::getNumIterations | ( |  | ) | const`[inline]`

Get how many iterations it took to solve the problem.

Definition at line 619 of file BlisModel.h.

int BlisModel::getAveIterations | ( |  | ) | const`[inline]`

Get the average iterations it took to solve a lp.

Definition at line 622 of file BlisModel.h.

void BlisModel::addNumNodes | ( | int | newNodes = `1` | ) | `[inline]`

Increment node count.

Definition at line 625 of file BlisModel.h.

void BlisModel::addNumIterations | ( | int | newIter | ) | `[inline]`

Increment Iteration count.

Definition at line 628 of file BlisModel.h.

CoinMessageHandler* BlisModel::messageHandler | ( |  | ) | const`[inline]`

Get the message handler.

Definition at line 634 of file BlisModel.h.

BlisParams* BlisModel::BlisPar | ( |  | ) | `[inline]`

Access parameters.

Definition at line 638 of file BlisModel.h.

int BlisModel::getHotstartStrategy | ( |  | ) | `[inline]`

Don't know what it is.

Definition at line 642 of file BlisModel.h.

void BlisModel::setHotstartStrategy | ( | int | value | ) | `[inline]`

Definition at line 643 of file BlisModel.h.

virtual void BlisModel::registerKnowledge | ( |  | ) | `[virtual]`

Register knowledge.

Reimplemented from AlpsModel.

Reimplemented in VrpModel.

virtual AlpsEncoded* BlisModel::encode | ( |  | ) | const`[virtual]`

The method that encodes the model into a encoded object.

Reimplemented from AlpsKnowledge.

Reimplemented in VrpModel.

virtual void BlisModel::decodeToSelf | ( | AlpsEncoded & |  | ) | `[virtual]`

The method that decodes the model from a encoded object.

Reimplemented from AlpsModel.

Reimplemented in VrpModel.

void BlisModel::init | ( |  | ) | `[protected]`

Intialize member data.

void BlisModel::createObjects | ( |  | ) | `[protected]`

Create variables and constraints.

void BlisModel::gutsOfDestructor | ( |  | ) |

Actual destructor.

void BlisModel::setColMatrix | ( | CoinPackedMatrix * | mat | ) | `[inline]`

Pass a matrix in.

Definition at line 355 of file BlisModel.h.

void BlisModel::setNumCons | ( | int | num | ) | `[inline]`

Pass column upper bounds.

Definition at line 358 of file BlisModel.h.

void BlisModel::setNumVars | ( | int | num | ) | `[inline]`

Pass column upper bounds.

Definition at line 361 of file BlisModel.h.

void BlisModel::setNumElems | ( | int | num | ) | `[inline]`

Pass column upper bounds.

Definition at line 364 of file BlisModel.h.

void BlisModel::setConLb | ( | double * | cl | ) | `[inline]`

Pass column upper bounds.

Definition at line 367 of file BlisModel.h.

void BlisModel::setConUb | ( | double * | cu | ) | `[inline]`

Pass column lower bounds.

Definition at line 370 of file BlisModel.h.

void BlisModel::setVarLb | ( | double * | lb | ) | `[inline]`

Pass variable upper bounds.

Definition at line 373 of file BlisModel.h.

void BlisModel::setVarUb | ( | double * | ub | ) | `[inline]`

Pass variable lower bounds.

Definition at line 376 of file BlisModel.h.

void BlisModel::setColType | ( | char * | colType | ) | `[inline]`

Pass variable types.

Definition at line 379 of file BlisModel.h.

void BlisModel::setObjCoef | ( | double * | obj | ) | `[inline]`

Pass objective coefficients.

Definition at line 384 of file BlisModel.h.

virtual void BlisModel::readInstance | ( | const char * | dataFile | ) | `[virtual]`

For parallel code, only the master calls this function.

1) Read in the instance data 2) Set colMatrix_, varLB_, varUB_, conLB_, conUB numCols_, numRows_ 3) Set objCoef_ and objSense_ 4) Set colType_ ('C', 'I', or 'B') 5) Create variables and constraints 6) Set numCoreVariables_ and numCoreConstraints_

Reimplemented from AlpsModel.

Reimplemented in VrpModel.

virtual void BlisModel::importModel | ( | std::vector< BlisVariable * > | vars,
|  | std::vector< BlisConstraint * > | cons |
| ) |  |  | `[virtual]`

For parallel code, only the master calls this function.

Import model from vars and cons. 1) Set colMatrix_, varLB_, varUB_, conLB_, conUB numCols_, numRows_ 2) Set objCoef_ (Assume minimization) 3) Set colType_ ('C', 'I', or 'B') 4) Set variables_ and constraints_ 5) Set numCoreVariables_ and numCoreConstraints_ NOTE: Blis takes over the memory ownship of vars and cons, which means users must NOT free vars or cons.

virtual void BlisModel::readParameters | ( | const int | argnum,
|  | const char *const * | arglist |
| ) |  |  | `[virtual]`

Read in Alps, Blis parameters.

Reimplemented from AlpsModel.

Reimplemented in VrpModel.

virtual void BlisModel::writeParameters | ( | std::ostream & | outstream | ) | const`[virtual]`

Write out parameters.

Reimplemented from AlpsModel.

virtual AlpsTreeNode* BlisModel::createRoot | ( |  | ) | `[virtual]`

For parallel code, only the master calls this function.

Create the root node based on model.

Reimplemented from AlpsModel.

virtual bool BlisModel::setupSelf | ( |  | ) | `[virtual]`

All processes call this function.

Do necessary work to make model usable. Return success or not. 1) Set numIntObjects_, intColIndices_, intObjectIndices_ 2) Load problem to LP solver. 3) Create integer objects (must after load to lp since using lp info) 4) Set branch strategy 5) Add heuristics 6) Add Cgl cut generators

Reimplemented from AlpsModel.

virtual void BlisModel::preprocess | ( |  | ) | `[virtual]`

Preprocessing the model.

Reimplemented from AlpsModel.

virtual void BlisModel::postprocess | ( |  | ) | `[virtual]`

Postprocessing the searching results.

Reimplemented from AlpsModel.

virtual void BlisModel::setSolver | ( | OsiSolverInterface * | si | ) | `[inline, virtual]`

Set lp solver.

Definition at line 440 of file BlisModel.h.

virtual OsiSolverInterface* BlisModel::getSolver | ( |  | ) | `[inline, virtual]`

Get lp solver.

Definition at line 443 of file BlisModel.h.

virtual OsiSolverInterface* BlisModel::solver | ( |  | ) | `[inline, virtual]`

Get lp solver.

Definition at line 446 of file BlisModel.h.

bool BlisModel::resolve | ( |  | ) |

Resolving a lp.

void BlisModel::setActiveNode | ( | AlpsTreeNode * | node | ) | `[inline]`

Set active node.

Definition at line 452 of file BlisModel.h.

void BlisModel::setSolEstimate | ( | double | est | ) | `[inline]`

Set the solution estimate of the active node.

Definition at line 455 of file BlisModel.h.

int BlisModel::getNumStrong | ( |  | ) | `[inline]`

Get number of strong branchings.

Definition at line 458 of file BlisModel.h.

void BlisModel::addNumStrong | ( | int | num = `1` | ) | `[inline]`

Add num to number of strong branchings.

Definition at line 461 of file BlisModel.h.

int BlisModel::getNumBranchResolve | ( |  | ) | `[inline]`

Get the maximum number of resolve during branching.

Definition at line 464 of file BlisModel.h.

void BlisModel::setNumBranchResolve | ( | int | num | ) | `[inline]`

Set the maximum number of resolve during branching.

Definition at line 467 of file BlisModel.h.

double* BlisModel::getObjCoef | ( |  | ) | const`[inline]`

Get objective coefficients.

Definition at line 474 of file BlisModel.h.

const double* BlisModel::getColLower | ( |  | ) | `[inline]`

Get column lower bound.

Definition at line 477 of file BlisModel.h.

const double* BlisModel::getColUpper | ( |  | ) | `[inline]`

Get column upper bound.

Definition at line 480 of file BlisModel.h.

int BlisModel::getNumCols | ( |  | ) | `[inline]`

Get number of columns.

Definition at line 483 of file BlisModel.h.

int BlisModel::getNumRows | ( |  | ) | `[inline]`

Get number of rows.

Definition at line 486 of file BlisModel.h.

double* BlisModel::varLB | ( |  | ) | `[inline]`

Get variable bounds arrary.

Definition at line 489 of file BlisModel.h.

double* BlisModel::varUB | ( |  | ) | `[inline]`

Definition at line 490 of file BlisModel.h.

double* BlisModel::conLB | ( |  | ) | `[inline]`

Get original constraint bounds arrary.

Definition at line 493 of file BlisModel.h.

double* BlisModel::conUB | ( |  | ) | `[inline]`

Definition at line 494 of file BlisModel.h.

double* BlisModel::startVarLB | ( |  | ) | `[inline]`

The starting variable bounds arrary of a subproblem (internal use).

Definition at line 497 of file BlisModel.h.

double* BlisModel::startVarUB | ( |  | ) | `[inline]`

Definition at line 498 of file BlisModel.h.

double* BlisModel::startConLB | ( |  | ) | `[inline]`

The starting constraint bounds arrary of a subproblem (internal use).

Definition at line 501 of file BlisModel.h.

double* BlisModel::startConUB | ( |  | ) | `[inline]`

Definition at line 502 of file BlisModel.h.

int* BlisModel::tempVarLBPos | ( |  | ) | `[inline]`

Temparory storage.

Definition at line 505 of file BlisModel.h.

int* BlisModel::tempVarUBPos | ( |  | ) | `[inline]`

Definition at line 506 of file BlisModel.h.

int* BlisModel::tempConLBPos | ( |  | ) | `[inline]`

Definition at line 507 of file BlisModel.h.

int* BlisModel::tempConUBPos | ( |  | ) | `[inline]`

Definition at line 508 of file BlisModel.h.

double BlisModel::getLpObjValue | ( |  | ) | const`[inline]`

Get current objective function value.

Definition at line 515 of file BlisModel.h.

const double* BlisModel::getLpSolution | ( |  | ) | const`[inline]`

Get active lp solution.

Definition at line 518 of file BlisModel.h.

int BlisModel::getNumSolutions | ( |  | ) | const`[inline]`

Get number of solutions.

Definition at line 525 of file BlisModel.h.

int BlisModel::getNumHeurSolutions | ( |  | ) | const`[inline]`

Get number of heuristic solutions.

Definition at line 528 of file BlisModel.h.

double* BlisModel::incumbent | ( |  | ) | `[inline]`

Return best ip solution found so far.

Definition at line 531 of file BlisModel.h.

int BlisModel::storeSolution | ( | BlisSolutionType | how,
|  | BlisSolution * | sol |
| ) |  |  |

Record a new incumbent solution and update objectiveValue.

double BlisModel::getCutoff | ( |  | ) | const`[inline]`

Get cut off value.

Definition at line 537 of file BlisModel.h.

void BlisModel::setCutoff | ( | double | co | ) | `[inline]`

Set cut off value.

Definition at line 540 of file BlisModel.h.

BlisSolution* BlisModel::feasibleSolutionHeur | ( | const double * | solution | ) |

Test if a solution found by heuristic is feasible.

virtual BlisSolution* BlisModel::feasibleSolution | ( | int & | numIntegerInfs,
|  | int & | numObjectInfs |
| ) |  |  | `[virtual]`

Test the current LP solution for feasiblility.

Scan all objects for indications of infeasibility. This is broken down into simple integer infeasibility (`numIntegerInfs`) and all other reports of infeasibility(`numObjectInfs`).

virtual BlisSolution* BlisModel::userFeasibleSolution | ( | const double * | solution,
|  | bool & | feasible |
| ) |  |  | `[inline, virtual]`

User's criteria for a feasible solution.

If user think the given solution is feasible then need 1) set userFeasible to true, and 2) return a non-null solution. If user think the solution is infeasible then need 1) set userFeasible to false, and 2) return a null.

Reimplemented in VrpModel.

Definition at line 571 of file BlisModel.h.

BcpsBranchStrategy* BlisModel::branchStrategy | ( |  | ) | const`[inline]`

Get the current branching strategy.

Definition at line 587 of file BlisModel.h.

void BlisModel::setBranchingMethod | ( | BcpsBranchStrategy * | method | ) | `[inline]`

Set the branching strategy.

Definition at line 591 of file BlisModel.h.

void BlisModel::setBranchingMethod | ( | BcpsBranchStrategy & | method | ) | `[inline]`

Set the branching stratedy.

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 597 of file BlisModel.h.

BcpsBranchStrategy* BlisModel::rampUpBranchStrategy | ( |  | ) | const`[inline]`

Get the current branching strategy.

Definition at line 601 of file BlisModel.h.

int BlisModel::numObjects | ( |  | ) | const`[inline]`

Get the number of objects.

Definition at line 609 of file BlisModel.h.

void BlisModel::setNumObjects | ( | int | num | ) | `[inline]`

Set the number of objects.

Definition at line 612 of file BlisModel.h.

BcpsObject** BlisModel::objects | ( |  | ) | `[inline]`

Get the array of objects.

Definition at line 615 of file BlisModel.h.

BcpsObject* BlisModel::objects | ( | int | which | ) | `[inline]`

Get the specified object.

Definition at line 618 of file BlisModel.h.

void BlisModel::setSharedObjectMark | ( | int | i | ) | `[inline]`

Mark object to be shared.

Definition at line 621 of file BlisModel.h.

void BlisModel::clearSharedObjectMark | ( |  | ) | `[inline]`

Clear all the share mark.

Definition at line 624 of file BlisModel.h.

void BlisModel::deleteObjects | ( |  | ) |

Delete all object information.

void BlisModel::addObjects | ( | int | numObjects,
|  | BcpsObject ** | objects |
| ) |  |  |

Add in object information.

Objects are cloned; the owner can delete the originals.

void BlisModel::createIntgerObjects | ( | bool | startAgain | ) |

Identify integer variable.

int* BlisModel::getIntObjIndices | ( |  | ) | const`[inline]`

Get integers' object indices.

Definition at line 642 of file BlisModel.h.

int BlisModel::getNumIntObjects | ( |  | ) | const`[inline]`

Get number of integers.

Definition at line 645 of file BlisModel.h.

int* BlisModel::getIntColIndices | ( |  | ) | const`[inline]`

Get integers' column indices.

Definition at line 648 of file BlisModel.h.

bool BlisModel::checkInteger | ( | double | value | ) | const`[inline]`

Check if a value is integer.

Definition at line 651 of file BlisModel.h.

void BlisModel::analyzeObjective | ( |  | ) |

void BlisModel::addHeuristic | ( | BlisHeuristic * | heur | ) |

Add a heuristic.

BlisHeuristic* BlisModel::heuristics | ( | int | i | ) | const`[inline]`

Get a specific heuristic.

Definition at line 672 of file BlisModel.h.

int BlisModel::numHeuristics | ( |  | ) | const`[inline]`

Get the number of heuristics.

Definition at line 675 of file BlisModel.h.

void BlisModel::addCutGenerator | ( | BlisConGenerator * | generator | ) |

Add a Blis cut generator.

void BlisModel::addCutGenerator | ( | CglCutGenerator * | generator,
|  | const char * | name = `NULL`,
|  | BlisCutStrategy | strategy = `BlisCutStrategyAuto`,
|  | int | cutGenerationFrequency = `1`,
|  | bool | normal = `true`,
|  | bool | atSolution = `false`,
|  | bool | whenInfeasible = `false` |
| ) |  |  |

Add a Cgl cut generator.

BlisConGenerator* BlisModel::cutGenerators | ( | int | i | ) | const`[inline]`

Get a specific cut generator.

Definition at line 694 of file BlisModel.h.

int BlisModel::numCutGenerators | ( |  | ) | const`[inline]`

Get the number of cut generators.

Definition at line 697 of file BlisModel.h.

int BlisModel::getMaxNumCons | ( |  | ) | const`[inline]`

Get the max number of cuts can be generated.

Definition at line 700 of file BlisModel.h.

void BlisModel::setMaxNumCons | ( | int | m | ) | `[inline]`

Set the max number of cuts can be generated.

Definition at line 703 of file BlisModel.h.

BcpsConstraintPool* BlisModel::constraintPool | ( |  | ) | `[inline]`

Access constraint pool.

Definition at line 706 of file BlisModel.h.

BcpsConstraintPool* BlisModel::constraintPoolReceive | ( |  | ) | `[inline]`

Access receive constraint pool.

Definition at line 709 of file BlisModel.h.

BcpsConstraintPool* BlisModel::constraintPoolSend | ( |  | ) | `[inline]`

Access send constraint pool.

Definition at line 713 of file BlisModel.h.

int BlisModel::getNumOldConstraints | ( |  | ) | const`[inline]`

Get number of old constraints.

Definition at line 717 of file BlisModel.h.

void BlisModel::setNumOldConstraints | ( | int | num | ) | `[inline]`

Set number of old constraints.

Definition at line 720 of file BlisModel.h.

int BlisModel::getOldConstraintsSize | ( |  | ) | const`[inline]`

Get max number of old constraints.

Definition at line 723 of file BlisModel.h.

void BlisModel::setOldConstraintsSize | ( | int | num | ) | `[inline]`

Set max number of old constraints.

Definition at line 726 of file BlisModel.h.

BlisConstraint** BlisModel::oldConstraints | ( |  | ) | `[inline]`

Access old constraints.

Definition at line 729 of file BlisModel.h.

void BlisModel::setOldConstraints | ( | BlisConstraint ** | old | ) | `[inline]`

set old constraints.

Definition at line 732 of file BlisModel.h.

void BlisModel::delOldConstraints | ( |  | ) | `[inline]`

Set max number of old constraints.

Definition at line 735 of file BlisModel.h.

BlisCutStrategy BlisModel::getCutStrategy | ( |  | ) | const`[inline]`

Query constraint generation strategy.

Definition at line 742 of file BlisModel.h.

void BlisModel::setCutStrategy | ( | BlisCutStrategy | u | ) | `[inline]`

Set constraint generation strategy.

Definition at line 747 of file BlisModel.h.

int BlisModel::getCutGenerationFrequency | ( |  | ) | const`[inline]`

Query constraint generation frequency.

Definition at line 750 of file BlisModel.h.

void BlisModel::setCutStrategy | ( | int | f | ) | `[inline]`

Set constraint generation frequency.

Definition at line 753 of file BlisModel.h.

int BlisModel::getDenseConCutoff | ( |  | ) | const`[inline]`

Get the thresheld to be considered as a dense constraint.

Definition at line 756 of file BlisModel.h.

void BlisModel::setDenseConCutoff | ( | int | cutoff | ) | `[inline]`

Set the thresheld to be considered as a dense constraint.

Definition at line 759 of file BlisModel.h.

double* BlisModel::getConRandoms | ( |  | ) | const`[inline]`

Get randoms for check parallel constraints.

Definition at line 762 of file BlisModel.h.

void BlisModel::passInPriorities | ( | const int * | priorities,
|  | bool | ifNotSimpleIntegers,
|  | int | defaultValue = `1000` |
| ) |  |  |

Pass in branching priorities.

If ifClique then priorities are on cliques otherwise priorities are on integer variables. Other type (if exists set to default) 1 is highest priority. (well actually -INT_MAX is but that's ugly) If hotstart > 0 then branches are created to force the variable to the value given by best solution. This enables a sort of hot start. The node choice should be greatest depth and hotstart should normally be switched off after a solution.

If ifNotSimpleIntegers true then appended to normal integers

const int* BlisModel::priority | ( |  | ) | const`[inline]`

Priorities.

Definition at line 787 of file BlisModel.h.

int BlisModel::priority | ( | int | sequence | ) | const`[inline]`

Returns priority level for an object (or 1000 if no priorities exist).

Definition at line 790 of file BlisModel.h.

double BlisModel::getNodeWeight | ( |  | ) | const`[inline]`

Definition at line 795 of file BlisModel.h.

void BlisModel::setNodeWeight | ( | double | nw | ) | `[inline]`

Definition at line 797 of file BlisModel.h.

virtual void BlisModel::modelLog | ( |  | ) | `[virtual]`

Log of specific models.

Reimplemented from AlpsModel.

int BlisModel::getNumNodes | ( |  | ) | const`[inline]`

Get how many Nodes it took to solve the problem.

Definition at line 808 of file BlisModel.h.

int BlisModel::getNumIterations | ( |  | ) | const`[inline]`

Get how many iterations it took to solve the problem.

Definition at line 811 of file BlisModel.h.

int BlisModel::getAveIterations | ( |  | ) | const`[inline]`

Get the average iterations it took to solve a lp.

Definition at line 814 of file BlisModel.h.

void BlisModel::addNumNodes | ( | int | newNodes = `1` | ) | `[inline]`

Increment node count.

Definition at line 817 of file BlisModel.h.

void BlisModel::addNumIterations | ( | int | newIter | ) | `[inline]`

Increment Iteration count.

Definition at line 820 of file BlisModel.h.

CoinMessageHandler* BlisModel::blisMessageHandler | ( |  | ) | const`[inline]`

Get the message handler.

Definition at line 826 of file BlisModel.h.

CoinMessages BlisModel::blisMessages | ( |  | ) | `[inline]`

Return messages.

Definition at line 830 of file BlisModel.h.

BlisParams* BlisModel::BlisPar | ( |  | ) | `[inline]`

Access parameters.

Definition at line 834 of file BlisModel.h.

virtual void BlisModel::nodeLog | ( | AlpsTreeNode * | node,
|  | bool | force |
| ) |  |  | `[virtual]`

Node log.

Reimplemented from AlpsModel.

virtual bool BlisModel::fathomAllNodes | ( |  | ) | `[virtual]`

Return true, if all nodes can be fathomed.

Reimplemented from AlpsModel.

AlpsReturnStatus BlisModel::encodeBlis | ( | AlpsEncoded * | encoded | ) | const`[protected]`

Pack Blis portion of the model into an encoded object.

AlpsReturnStatus BlisModel::decodeBlis | ( | AlpsEncoded & | encoded | ) | `[protected]`

Unpack Blis portion of the model from an encoded object.

void BlisModel::packSharedPseudocost | ( | AlpsEncoded * | encoded,
|  | int | numToShare |
| ) |  |  | `[protected]`

Retrieve and pack shared pseudocost.

void BlisModel::unpackSharedPseudocost | ( | AlpsEncoded & | encoded | ) | `[protected]`

Unpack and store shared pseduocost.

void BlisModel::packSharedConstraints | ( | AlpsEncoded * | encoded | ) | `[protected]`

Retrieve and pack shared constraints.

void BlisModel::unpackSharedConstraints | ( | AlpsEncoded & | encoded | ) | `[protected]`

Unpack and store shared constraints.

void BlisModel::packSharedVariables | ( | AlpsEncoded * | encoded | ) | `[protected]`

Retrieve and pack shared variables.

void BlisModel::unpackSharedVariables | ( | AlpsEncoded & | encoded | ) | `[protected]`

Unpack and store shared variables.

virtual void BlisModel::registerKnowledge | ( |  | ) | `[virtual]`

Register knowledge.

Reimplemented from AlpsModel.

Reimplemented in VrpModel.

virtual AlpsEncoded* BlisModel::encode | ( |  | ) | const`[virtual]`

The method that encodes the model into an encoded object.

Reimplemented from AlpsKnowledge.

Reimplemented in VrpModel.

virtual void BlisModel::decodeToSelf | ( | AlpsEncoded & |  | ) | `[virtual]`

The method that decodes the model from an encoded object.

Reimplemented from AlpsModel.

Reimplemented in VrpModel.

virtual AlpsEncoded* BlisModel::packSharedKnowlege | ( |  | ) | `[virtual]`

Pack knowledge to be shared with others into an encoded object.

Return NULL means that no knowledge can be shared.

Reimplemented from AlpsModel.

virtual void BlisModel::unpackSharedKnowledge | ( | AlpsEncoded & |  | ) | `[virtual]`

Unpack and store shared knowledge from an encoded object.

Reimplemented from AlpsModel.

virtual void BlisModel::presolveForTheWholeTree | ( |  | ) | `[virtual]`

## Member Data Documentation

OsiSolverInterface * BlisModel::lpSolver_`[private]`

Lp solver.

Actually used.

If using presolve, then it is presolved; otherwise it is the original.

Definition at line 69 of file BlisModel.h.

CoinPackedMatrix * BlisModel::colMatrix_`[private]`

Orignial column majored matrix.

Column majored matrix.

(For MPS file, etc.)

Definition at line 76 of file BlisModel.h.

double* BlisModel::origVarLB_`[private]`

Original variable and constraint bounds.

Definition at line 80 of file BlisModel.h.

double* BlisModel::origVarUB_`[private]`

Original variable and constraint bounds.

Definition at line 81 of file BlisModel.h.

double* BlisModel::origConLB_`[private]`

Original variable and constraint bounds.

Definition at line 82 of file BlisModel.h.

double* BlisModel::origConUB_`[private]`

Original variable and constraint bounds.

Definition at line 83 of file BlisModel.h.

int BlisModel::numCols_`[private]`

Number of columns/rows/elements in active subproblem.

Number of columns/rows/elements.

Initaially is the same as numCoreVariables.

Definition at line 89 of file BlisModel.h.

int BlisModel::numRows_`[private]`

Original variable and constraint bounds.

Definition at line 90 of file BlisModel.h.

int BlisModel::numElems_`[private]`

Original variable and constraint bounds.

Definition at line 91 of file BlisModel.h.

double BlisModel::objSense_`[private]`

Objective function.

Definition at line 96 of file BlisModel.h.

double * BlisModel::objCoef_`[private]`

Original variable and constraint bounds.

Definition at line 97 of file BlisModel.h.

int BlisModel::numIntVars_`[private]`

Column types.

Definition at line 102 of file BlisModel.h.

int* BlisModel::intVars_`[private]`

Original variable and constraint bounds.

Definition at line 103 of file BlisModel.h.

char * BlisModel::colType_`[private]`

Original variable and constraint bounds.

Definition at line 104 of file BlisModel.h.

int BlisModel::numSolutions_`[private]`

Definition at line 111 of file BlisModel.h.

int BlisModel::numHeurSolutions_`[private]`

Definition at line 112 of file BlisModel.h.

double BlisModel::incObjValue_`[private]`

Saved lp solution for temporatory usage.

Incumbent objective value.

Definition at line 118 of file BlisModel.h.

double * BlisModel::incumbent_`[private]`

Incumbent.

Definition at line 121 of file BlisModel.h.

double BlisModel::cutoff_`[private]`

Cutoff in lp solver.

Definition at line 124 of file BlisModel.h.

double BlisModel::cutoffInc_`[private]`

Cutoff increment.

Definition at line 127 of file BlisModel.h.

double * BlisModel::startVarLB_`[private]`

Starting var/con bounds for processing each node.

Definition at line 135 of file BlisModel.h.

double * BlisModel::startVarUB_`[private]`

Original variable and constraint bounds.

Definition at line 136 of file BlisModel.h.

double * BlisModel::startConLB_`[private]`

Original variable and constraint bounds.

Definition at line 137 of file BlisModel.h.

double * BlisModel::startConUB_`[private]`

Original variable and constraint bounds.

Definition at line 138 of file BlisModel.h.

BcpsBranchStrategy * BlisModel::branchStrategy_`[private]`

Variable selection function.

Definition at line 142 of file BlisModel.h.

int BlisModel::hotstartStrategy_`[private]`

Definition at line 147 of file BlisModel.h.

int BlisModel::numObjects_`[private]`

Number of objects.

Definition at line 150 of file BlisModel.h.

BcpsObject ** BlisModel::objects_`[private]`

The set of objects.

Definition at line 153 of file BlisModel.h.

int * BlisModel::priority_`[private]`

Priorities of integer object.

Definition at line 156 of file BlisModel.h.

AlpsTreeNode * BlisModel::activeNode_`[private]`

Active node.

Definition at line 159 of file BlisModel.h.

int BlisModel::numStrong_`[private]`

Number of strong branching.

Definition at line 162 of file BlisModel.h.

double BlisModel::nodeWeight_`[private]`

Definition at line 165 of file BlisModel.h.

int BlisModel::numHeuristics_`[private]`

Number of heuristics.

Definition at line 172 of file BlisModel.h.

BlisHeuristic ** BlisModel::heuristics_`[private]`

The list of heuristics.

Definition at line 175 of file BlisModel.h.

int BlisModel::useCons_`[private]`

If use cut generators.

Definition at line 182 of file BlisModel.h.

int BlisModel::numCutGenerators_`[private]`

Number of cut generators used.

Definition at line 185 of file BlisModel.h.

int BlisModel::maxNumCons_`[private]`

Number of cuts can be generators.

Definition at line 188 of file BlisModel.h.

BlisConGenerator ** BlisModel::generators_`[private]`

The list of cut generators used.

Definition at line 191 of file BlisModel.h.

BcpsConstraintPool * BlisModel::constraintPool_`[private]`

Store all the cuts.

Definition at line 194 of file BlisModel.h.

BlisConstraint ** BlisModel::oldConstraints_`[private]`

Temporary store old cuts at a node when installing a node.

Definition at line 197 of file BlisModel.h.

int BlisModel::oldConstraintsSize_`[private]`

The memory size allocated for oldConstraints_.

Definition at line 200 of file BlisModel.h.

int BlisModel::numOldConstraints_`[private]`

Number of old constraints.

Definition at line 203 of file BlisModel.h.

double * BlisModel::conRandoms_`[private]`

Random keys.

Definition at line 206 of file BlisModel.h.

int BlisModel::denseConCutoff_`[private]`

Dense constraint cutoff.

Definition at line 209 of file BlisModel.h.

BlisParams * BlisModel::BlisPar_`[private]`

Blis parameters.

Definition at line 216 of file BlisModel.h.

CoinMessageHandler* BlisModel::handler_`[private]`

Message handler.

Definition at line 219 of file BlisModel.h.

int BlisModel::numNodes_`[private]`

Number of processed nodes.

Definition at line 222 of file BlisModel.h.

int BlisModel::numIterations_`[private]`

Number of lp(Simplex) iterations.

Definition at line 225 of file BlisModel.h.

int BlisModel::aveIterations_`[private]`

Average number of lp iterations to solve a subproblem.

Definition at line 228 of file BlisModel.h.

int * BlisModel::tempVarLBPos_`[private]`

Tempory storage for var/con indices.

Definition at line 236 of file BlisModel.h.

int * BlisModel::tempVarUBPos_`[private]`

Original variable and constraint bounds.

Definition at line 237 of file BlisModel.h.

int * BlisModel::tempConLBPos_`[private]`

Original variable and constraint bounds.

Definition at line 238 of file BlisModel.h.

int * BlisModel::tempConUBPos_`[private]`

Original variable and constraint bounds.

Definition at line 239 of file BlisModel.h.

bool BlisModel::isRoot_

If root node.

Definition at line 245 of file BlisModel.h.

double BlisModel::startTime_

Search starting time.

Definition at line 248 of file BlisModel.h.

double BlisModel::timeLimit_

Max solution time.

Definition at line 251 of file BlisModel.h.

double BlisModel::integerTol_

Integer tolerance.

Definition at line 254 of file BlisModel.h.

double BlisModel::optimalRelGap_

Relative optimal gap.

Input relative optimal gap.

Definition at line 257 of file BlisModel.h.

double BlisModel::optimalAbsGap_

Absolute optimal gap.

Input absolute optimal gap.

Definition at line 260 of file BlisModel.h.

bool BlisModel::useHeuristics_

If use heuristics.

Definition at line 263 of file BlisModel.h.

OsiCuts BlisModel::newCutPool_

Store new cuts in each pass.

Definition at line 266 of file BlisModel.h.

std::vector< AlpsTreeNode * > BlisModel::leafToRootPath

Record the path from leaf to root.

Definition at line 271 of file BlisModel.h.

OsiSolverInterface* BlisModel::origLpSolver_`[protected]`

Input by user.

Definition at line 78 of file BlisModel.h.

OsiSolverInterface* BlisModel::presolvedLpSolver_`[protected]`

Presolved.

Definition at line 80 of file BlisModel.h.

double* BlisModel::varLB_`[protected]`

Variable and constraint bounds.

Definition at line 94 of file BlisModel.h.

double* BlisModel::varUB_`[protected]`

Original variable and constraint bounds.

Definition at line 95 of file BlisModel.h.

double* BlisModel::conLB_`[protected]`

Original variable and constraint bounds.

Definition at line 96 of file BlisModel.h.

double* BlisModel::conUB_`[protected]`

Original variable and constraint bounds.

Definition at line 97 of file BlisModel.h.

int BlisModel::numIntObjects_`[protected]`

Column types.

Definition at line 115 of file BlisModel.h.

int* BlisModel::intColIndices_`[protected]`

Original variable and constraint bounds.

Definition at line 116 of file BlisModel.h.

std::vector<BcpsVariable *> BlisModel::inputVar_`[protected]`

User's input objects.

Definition at line 121 of file BlisModel.h.

std::vector<BcpsConstraint *> BlisModel::inputCon_`[protected]`

Original variable and constraint bounds.

Definition at line 122 of file BlisModel.h.

BlisPresolve* BlisModel::presolve_`[protected]`

Definition at line 129 of file BlisModel.h.

bool BlisModel::presolved`[protected]`

Definition at line 131 of file BlisModel.h.

bool BlisModel::problemSetup`[protected]`

Definition at line 132 of file BlisModel.h.

int* BlisModel::intObjIndices_`[protected]`

Definition at line 158 of file BlisModel.h.

BcpsBranchStrategy* BlisModel::rampUpBranchStrategy_`[protected]`

Definition at line 171 of file BlisModel.h.

BlisHotStartStrategy BlisModel::hotstartStrategy_`[protected]`

Definition at line 176 of file BlisModel.h.

char* BlisModel::sharedObjectMark_`[protected]`

The objects that can be shared.

Definition at line 185 of file BlisModel.h.

int BlisModel::numBranchResolve_`[protected]`

Maximum number of resolve during branching.

Definition at line 200 of file BlisModel.h.

BlisCutStrategy BlisModel::cutStrategy_`[protected]`

If use cut generators.

Definition at line 217 of file BlisModel.h.

int BlisModel::cutGenerationFrequency_`[protected]`

Frequency of cut generation.

Definition at line 220 of file BlisModel.h.

CoinMessageHandler* BlisModel::blisMessageHandler_`[protected]`

Message handler.

Definition at line 257 of file BlisModel.h.

CoinMessages BlisModel::blisMessages_`[protected]`

Blis messages.

Definition at line 260 of file BlisModel.h.

BcpsConstraintPool* BlisModel::constraintPoolSend_`[protected]`

Constraints that can be sent/broadcasted to other processes.

Definition at line 288 of file BlisModel.h.

BcpsConstraintPool* BlisModel::constraintPoolReceive_`[protected]`

Constraints that are received from other processses.

Definition at line 291 of file BlisModel.h.

int BlisModel::boundingPass_

The number of passes during bounding procedure.

Definition at line 299 of file BlisModel.h.

double BlisModel::currRelGap_

Current relative optimal gap.

Definition at line 311 of file BlisModel.h.

double BlisModel::currAbsGap_

Current absolute optimal gap.

Definition at line 314 of file BlisModel.h.

BlisHeurStrategy BlisModel::heurStrategy_

If use heuristics.

Definition at line 317 of file BlisModel.h.

int BlisModel::heurCallFrequency_

Frequency of using heuristics.

Definition at line 320 of file BlisModel.h.

The documentation for this class was generated from the following files:

- /home/coin/svn-release/Blis-0.93.2/Bcps/examples/Blis/BlisModel.h
- /home/coin/svn-release/Blis-0.93.2/Blis/src/BlisModel.h